/********************************************************************/
/*	SVI Common Source												*/
/********************************************************************/
#include "StdAfx.h"
#include "SVIPluginComm.h"

/********************************************************************/
/*	֐hcFIsFigure												*/
/*	֐́F`FbN										*/
/*	@\TvF^ꂽ񂪐ϊłDEF_OK,				*/
/*			  ϊłȂDEF_NGԂ						*/
/********************************************************************/
int IsFigure(
			CString& strCheckData )	// [IN] `FbNf[^
{
	int i;			// JE^
	int iStrLen;	// CStrData̒i[
	
	// ^ꂽ̕擾
	iStrLen = strCheckData.GetLength();
	if( iStrLen == 0 ) {
		// ^ꂽ񂪋̏ꍇ̃G[
		return DEF_ERR;
	}

	for( i = 0 ; i < iStrLen ; i++ ) {
		// ^ꂽ񂪐ϊ\ׂ
		if( isdigit( strCheckData.GetAt(i) ) == 0 ) {
			// ȊO̕ĂDEF_ERRԂ
			return DEF_ERR;
		}
	}

	return DEF_OK;
}	//	IsFigure()	EXIT

/********************************************************************/
/*	֐hcFCreateMapping											*/
/*	֐́FL}bsO									*/
/*	@\TvFL}bsO							*/
/*  ߂l  F\z/ُ											*/
/********************************************************************/
int CreateMapping(
				HANDLE*	hMapping,				// [IO] L}bsOnh			
				DWORD	dwMemorySize,			// [IN] LmۃTCY
				CString	strSharedMemoryName		// [IN] L
	) 
{
	// L}bsO
	*hMapping	= ::CreateFileMapping( INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, dwMemorySize, strSharedMemoryName );
	if( *hMapping == NULL ) {
		// L}bsOs
		AfxMessageBox( MSG_ERR_SHAREDMEMORY );
		return DEF_ERR;
	}
	return DEF_OK;
}	// CreateMapping End

/********************************************************************/
/*	֐hcFCheckMapping											*/
/*	֐́F}bvr[`FbN									*/
/*	@\TvF}bvꂽr[`FbN						*/
/*  ߂l  F/ُ												*/
/********************************************************************/
int CheckMapping( 
						HANDLE*	hMapping,			// [IO] L}bsOnh
						void*	pMapViewAddress		// [IN] }bvꂽr[̊JnAhX
					) 
{
	if( pMapViewAddress == NULL ) {
		AfxMessageBox( MSG_ERR_SHAREDMEMORYMUPPING );
		// L폜
		::CloseHandle( *hMapping );
		*hMapping	= NULL;
		return DEF_ERR;
	}
	return DEF_OK;
}	// CheckMapping End

/********************************************************************/
/*	֐hcFOpenMapping											*/
/*	֐́FLI[v									*/
/*	@\TvFLI[v								*/
/*  ߂l  F\z/ُ											*/
/********************************************************************/
int OpenMapping(
				DWORD	dwDesiredAccess,		// [IN] LANZX[h
				HANDLE*	hMapping,				// [IO] L}bsOnh			
				CString	strSharedMemoryName		// [IN] L
	) 
{
	// LI[v
	*hMapping	= ::OpenFileMapping( dwDesiredAccess, FALSE, strSharedMemoryName );
	if( *hMapping == NULL ) {
		// LI[vs
		AfxMessageBox( MSG_ERR_SHAREDMEMORYNOTFOUND );
		return DEF_ERR;
	}
	return DEF_OK;
}	// CreateMapping End

/********************************************************************/
/*	֐hcFCreateSharedMemory									*/
/*	֐́FL\z										*/
/*	@\TvFL\ziBYTE^j						*/
/*  ߂l  Fnh												*/
/********************************************************************/
HANDLE CreateSharedMemory( 
							  LPBYTE*	pDataBuff, 
							  HANDLE	hMapping, 
							  DWORD		dwSharedMemorySize,
							  CString	strSharedName )
{
	// L}bsO
	if( CreateMapping( &hMapping, dwSharedMemorySize, strSharedName ) == DEF_ERR ) {
		return NULL;
	}

	// LA}bsO
	*pDataBuff	= (LPBYTE)MapViewOfFile( hMapping, FILE_MAP_ALL_ACCESS, 0, 0, dwSharedMemorySize );

	if( CheckMapping( &hMapping, *pDataBuff ) == DEF_ERR ) {
		return NULL;
	}

	// 
	::ZeroMemory( *pDataBuff, dwSharedMemorySize );

	return hMapping;
}	// CreateSharedMemory End

/********************************************************************/
/*	֐hcFCreateSharedMemory									*/
/*	֐́FL\z										*/
/*	@\TvFL\ziBYTE^j						*/
/*  ߂l  Fnh												*/
/********************************************************************/
HANDLE CreateSharedMemory( 
							  PDMAD*	pDataBuff, 
							  HANDLE	hMapping, 
							  DWORD		dwSharedMemorySize,
							  CString	strSharedName )
{
	// L}bsO
	if( CreateMapping( &hMapping, dwSharedMemorySize, strSharedName ) == DEF_ERR ) {
		return NULL;
	}

	// LA}bsO
	*pDataBuff	= (PDMAD)MapViewOfFile( hMapping, FILE_MAP_ALL_ACCESS, 0, 0, dwSharedMemorySize );

	if( CheckMapping( &hMapping, *pDataBuff ) == DEF_ERR ) {
		return NULL;
	}

	// 
	::ZeroMemory( *pDataBuff, dwSharedMemorySize - 1 );

	return hMapping;
}	// CreateSharedMemory End

/********************************************************************/
/*	֐hcFCalcPadding											*/
/*	֐́FpfBOvZ										*/
/*	@\TvF摜̃pfBOvZ							*/
/*  ߂l  F쐬/ُ											*/
/********************************************************************/
DWORD CalcPadding( DWORD dwXSize ) 
{
	DWORD	dwPadding;

	dwPadding	= 4 - ( ( dwXSize * RGB24LENGTH ) % 4 );
	if( dwPadding == 4 ) {
		dwPadding	= 0;
	}

	return dwPadding;
}	// CalcPadding End
